/**
 *  Copyright (c) 2015,
 *  BTC Embedded Systems AG, Oldenburg, Germany
 *  All rights reserved
 *  ---------------------------------------------------------
 *  $Author: $
 *  $Date:  $
 *  $Revision: $
 **/

package com.btc.ep.base.bl.impl;

import com.btc.ep.base.bl.Vector;

/**
 * This class implements the VectorImpl
 */
public class VectorImpl extends NamedElementImpl implements Vector {

    private long elementCount = 0;

    /**
     * JPA Entity Default constructor
     * <p>The default constructor must be a public or protected zero-argument constructor.</p>
     */
    public VectorImpl() {
    }


    @Override
    public void incrementElementCount(long offset) {
        elementCount = elementCount + offset;
    }

    @Override
    public void decrementElementCount(long offset) {
        if (elementCount >= offset) {
            elementCount = elementCount - offset;
        } else {
            elementCount = 0;
        }
    }

    /**
     * Get elementCount.
     * 
     * @return the elementCount
     */
    public long getElementCount() {
        return elementCount;

    }

    /**
     * Set elementCount.
     * 
     * @param elementCount the elementCount to set
     */
    public void setElementCount(long elementCount) {
        this.elementCount = elementCount;

    }

}
