/**
 *  Copyright (c) 2014, 
 *  BTC Embedded Systems AG, Oldenburg, Germany  
 *  All rights reserved
 *  --------------------------------------------------------- 
 *  $Author: $
 *  $Date:  $
 *  $Revision: $
 **/

package com.btc.ep.base.dal.internal;

import com.btc.ep.base.bl.repository.StandardRepository;
import com.btc.ep.core.Services;
import com.btc.ep.dal.persist.PersistenceManager;
import com.btc.ep.dal.persist.impl.PersistenceService;

/**
 * This class is a standard repository.
 * 
 * @author Simon Kollmann
 */
public class StandardRepositoryImpl implements StandardRepository {

    /**
     * Injected by OSGi.
     */
    private PersistenceManager persistenceManager;

    /**
     * set PersistenceManager
     *
     * @param persistenceManager persistence manager
     */
    public void setPersistenceManager(PersistenceManager persistenceManager) {
        this.persistenceManager = persistenceManager;
    }

    /**
     * Get access to the PersistenceManager
     *
     * @return PersistenceManager
     */
    private PersistenceManager getPersistenceManager() {
        if (persistenceManager == null) {
            persistenceManager = Services.get(PersistenceManager.class);
        }
        return persistenceManager;
    }

    /**
     * Get easy access to the PersistenceService
     *
     * @return PersistenceService
     */
    private PersistenceService getPersistenceService() {
        return getPersistenceManager().getPersistenceService();
    }


    @Override
    public boolean clearDatabase() {
        getPersistenceService().updateQuery("DELETE FROM Object"); // delete whole database
        return true;
    }

}
