/**
 *  @file      TransactionException.java
 *  @author    Stefan Reichert
 *
 *  Copyright (c)
 *  BTC Embedded Systems AG
 *  Oldenburg, Germany
 *
 *  --------------------------------
 *  $$Author: ${user} $$
 *  $$Date: ${date} ${time} $$
 *  $$Rev: revision number $$
 *  --------------------------------
 */
package com.btc.ep.base.transactions;

// ---------------------------------------------------------------------------
// Implementation
// ---------------------------------------------------------------------------

/**
 * Exception that refers to an illegal state in exception handling. This could either be a missing transaction or
 * missing collaborators for the transaction handling.
 */
public class TransactionException extends RuntimeException {

    /** the serial version UID. */
    private static final long serialVersionUID = 1L;

    /**
     * Constructor for a {@link TransactionException} having a message as parameter.
     *
     * @param message The human readable message
     */
    public TransactionException(String message) {
        super(message);
    }

    /**
     * Constructor for a {@link TransactionException} having a message and a cause as parameter.
     *
     * @param message The human readable message
     * @param cause The causing runtime exception
     */
    public TransactionException(String message, RuntimeException cause) {
        super(message, cause);
    }

}

// ---------------------------------------------------------------------------
// END OF FILE
// ---------------------------------------------------------------------------
