/**
 *  @file      Activator.java
 *  @author    Stefan Reichert
 *
 *  Copyright (c)
 *  BTC Embedded Systems AG
 *  Oldenburg, Germany
 *  
 *  --------------------------------
 *  $$Author: ${user} $$
 *  $$Date: ${date} ${time} $$
 *  $$Rev: revision number $$
 *  --------------------------------
 */
package com.btc.ep.base.transactions.internal;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;

import com.btc.ep.base.transactions.TransactionManager;

//---------------------------------------------------------------------------
//Implementation
//---------------------------------------------------------------------------

/**
 * This class represents the activator. It is used to get hold of the TransactionManager instance.
 */
public class Activator implements BundleActivator {

    private static BundleContext bundleContext;

    private static ServiceReference<TransactionManager> transactionManagerReference;

    /**
     * Returns the TransactionManager instance from the the bundle context.
     *
     * @return a TransactionManager implementation
     */
    public static TransactionManager getTransactionManager() {
        transactionManagerReference = Activator.bundleContext.getServiceReference(TransactionManager.class);
        return bundleContext.getService(transactionManagerReference);
    }

    /**
     * {@inheritDoc}
     * 
     * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
     */
    @Override
    public void start(BundleContext bundleContext) throws Exception {
        Activator.bundleContext = bundleContext;
        transactionManagerReference = Activator.bundleContext.getServiceReference(TransactionManager.class);
    }

    /**
     * {@inheritDoc}
     * 
     * @see org.osgi.framework.BundleActivator#stop(org.osgi.framework.BundleContext)
     */
    @Override
    public void stop(BundleContext arg0) throws Exception {
        Activator.bundleContext = null;
    }
}